/**
 * The kobold's relation with the Ten Paw Gang, a band of five kobolds
 * first encounterable in the forest.
 */
function TenPawGang() {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    // PUBLIC MEMBERS \\        this.public = "test";
    this.relation = TenPawGangEnum.UNMET;
    this.footsie = TenPawGangFootsieEnum.NODIFFERENT;
    this.usedRock = false;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};
    
    /**
     * Loads this object from a type-stripped version thereof.
     * @param {TenPawGang-stripped} tenPawGang A TenPawGang object, stripped of private members and all functions.
     */
    this.load = function (tenPawGang) {
        if(!tenPawGang) {
            that.load(new TenPawGang());
            return;
        }
        
        that.relation = tenPawGang.relation;
        that.footsie = tenPawGang.footsie;
        that.usedRock = tenPawGang.usedRock;
    };
}
