/**
 * Flee section of Varanar, Night Two.
 * @param {NightTwoController} controller The Night Two controller.
 */
function NightTwoAlleyStay(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new NightTwoAlleyStayContinue(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.varanar.nightTwo.alleyPiss = true;
        var underwear = ctrl.misc.underwear();
        var pants = ctrl.misc.pants();
        var shirt = ctrl.misc.shirt();
        var clothing = underwear || pants || shirt;
        var toReturn = `[p]
                            You don't have a choice.
                            The hoodlum is twice your size,
                            and he has a bunch of equally menacing friends waiting just outside of the alleyway to come [b]fuck you up[/b] unless you do as he says.
                            You glare up at the human.
                            He smirks down at you.
                            Taking your silence for acceptance, he grabs his humongous shaft, and points it directly at you.
                            Before you have a chance to protest, the drunkard  releases his bladder, and a thick stream of dark-yellow, acrid,
                            foul-smelling urine hits you straight on the forehead, splattering across the entirety of your face.
                        [/p]
                        [p]
                            You immediately close your eyes and your mouth, your tooth-baring scowl replaced by a pathetic, submissive frown.
                            The man lets out a domineering chuckle, as he begins to shift his member about, directing the stream of disgusting, lukewarm liquid.
                            First, he ensures your entire face has been coated, from the top of your head to the underside of your muzzle.
                            You gag and retch as a few droplets find their way inside of you nostrils,
                            an absolutely [b]vile[/b] taste building up at the back of your throat, as though you can [b]taste[/b] it.
                        [/p]
                        [p]
                            You lift up your hands and your arms in an attempt to cover your face, trying to [b]block[/b] the flow, but the human simply lowers his aim,
                            ${clothing ? `completely [b]drenching[/b] your clothing` : `soaking your body`} in piss instead.
                            A small puddle of the stuff forms underneath you, which makes you feel even [b]more[/b] dirty and uncomfortable,
                            as though you're [b]wallowing[/b] in it.
                            On the very [b]verge[/b] of throwing up, you finally feel the flow starting to lessen,
                            the once-powerful stream blasting across your chest reduced to a minor trickle spilling down onto your legs.
                        [/p]
                        [p]
                            "[color=dred]You look good in yellow.[/color]" the man taunts, pulling up and re-buttoning his pants.
                            Snickering at his own joke, he realizes you aren't sharing his jolly sentiment.
                            He crudely spits on the ground next to you, his saliva quickly mixing with the expanding pool of urine.
                            "[color=dred]Next time, I'll let my buddies take a leak on you as well, you ungrateful [b]bitch[/b].
                            That's all you [b]filthy lizards[/b] are good for.[/color]"
                            That last part being more of a mumbling to himself, the man turns around and begins to walk away,
                            leaving you crying in the middle of a puddle of his piss.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = ctrl.alleyStay.continued() ? "disabled" : "";
        var isSelected = ctrl.alleyStay.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.hideAttack.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (ctrl.alleyRunFail.get() !== NightTwoAlleyRunFailChoice.STAY) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += ctrl.alleyEager.change();
        part += buildChoice();
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (ctrl.alleyRunFail.get() !== NightTwoAlleyRunFailChoice.STAY) {
            return;
        }

        next.registerListeners();

        if (ctrl.alleyStay.continued()) {
            return;
        }

        registerNextListener();
    };
}
