/**
 * What the kobold did during the second night of Varanar.
 */
function NightTwoShared() {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    // PUBLIC MEMBERS \\        this.public = "test";
    this.arrivalEnum = {
        REGULAR: 1,
        RIVER: 2
    };
    this.arrival = that.arrivalEnum.REGULAR;
    this.alleyAttack = false;
    this.alleyPiss = false;
    this.beatUp = false;
    this.pissSlut = false;
    this.fuckSlut = false;
    this.fetishSlut = false;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Loads this object from a type-stripped version thereof.
     * @param {NightTwoShared-stripped} nightTwo A NightTwoShared object, stripped of private members and all functions.
     */
    this.load = function (nightTwo) {
        if (!nightTwo) {
            that.load(new NightTwoShared());
            return;
        }
        that.arrival = nightTwo.arrival;
        that.alleyAttack = nightTwo.alleyAttack;
        that.alleyPiss = nightTwo.alleyPiss;
        that.beatUp = nightTwo.beatUp;
        that.pissSlut = nightTwo.pissSlut;
        that.fuckSlut = nightTwo.fuckSlut;
        that.fetishSlut = nightTwo.fetishSlut;
    };
}

